/****************************************************************************
** mod_template.h
**
** Template for plugins
**
** Author: Author Name <email@address>
**
** Copyright (c) 2000 Mount Linux Inc.
**
** This file is part of Mount Linux Olympus.
**
** This program is free software; you can redistribute it and/or modify it
** under the terms of the GNU General Public License version 2 as published
** by the Free Software Foundation.
**
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
** or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
** for more details.
**
** You should have received a copy of version 2 of the GNU General Public
** License along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*****************************************************************************/

#ifndef _mod_template_h
#define _mod_template_h

#include <qdialog.h>
#include <qlabel.h>

#include "plugin.h"

/*
 * forward ref of mod_template, only necessary because we are declaring
 * two classes in this file that need each other.
 *
 * for larger plugins, consider putting each class in its own .h, in
 * which case forward references would be unecessary
 */
class mod_template;

/*
 * a GUI class that is used for user interaction
 */
class mod_templatewin : public QDialog
{
    Q_OBJECT

    public:
        mod_templatewin(unsigned int _moduleID, mod_template *_parentPlugin, char *name);
        ~mod_templatewin();

        void closeEvent(QCloseEvent *e);

    private:
        unsigned int moduleID;
        mod_template *parentPlugin;
};

/*
 * the actual plugin subclass
 */
class mod_template : public plugin
{
    public:
        mod_template();
        virtual ~mod_template();

        // these return info on the plugin in question
        virtual char * name() { return "Template"; }
        virtual char * group() { return "Development"; }
        virtual char * desc() { return "Olympus plugin template."; }
    	virtual char * credits() { return "Your Name <your email address> Organisation."; }
        virtual char * version() { return "0.1"; }

        // for receiving netmessage objects
        virtual void recv(netmessage *, int);

        // to get focus
        virtual void getFocus();

        // the "main" function for the plugin
        virtual void exec(hostObj * _host, unsigned int _moduleID, moduleList * _modList);

    private:
        mod_templatewin *templateWin;
};

#endif // _mod_template_h
